#include "fyll.h"
#include "texture.h"

#include <cstdlib>

#include <GL/gl.h>
#include <GL/glu.h>

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
void swap(unsigned char & a, unsigned char & b);

texture::texture(const char* filename) {
	SDL_Surface *image;
	image = IMG_Load(filename);

	if(image == NULL) printf("FAEN!\n");
	GLuint idarr[1];
    glGenTextures(1, idarr);
	num = idarr[0];

    glBindTexture(GL_TEXTURE_2D, num);

    int width  = image->w;
    int height = image->h;
    unsigned char * data = (unsigned char *) (image->pixels);
    unsigned char * newData = new unsigned char[width*height*3];
    int channels = 3;

    int bytesPerPixel = image->format->BytesPerPixel;

    for( int i = 0 ; i < (height / 2) ; ++i )
        for( int j = 0 ; j < width * bytesPerPixel; j += bytesPerPixel )
            for(int k = 0; k < bytesPerPixel; ++k)
                swap( data[ (i * width * bytesPerPixel) + j + k], data[ ( (height - i - 1) * width * bytesPerPixel ) + j + k]);
 

    for(int i = 0; i < (width * height); ++i)
    {
        unsigned char r,g,b;

        Uint32 pixel_value = 0;

        for(int j = bytesPerPixel - 1 ; j >=0; --j)
        {
            pixel_value = pixel_value << 8;
            pixel_value = pixel_value | data[ (i * bytesPerPixel) + j ];
        }

        SDL_GetRGB(pixel_value, image->format, (Uint8 *)&r, (Uint8 *)&g, (Uint8 *)&b);

        newData[(i * channels) + 0] = r;
        newData[(i * channels) + 1] = g;
        newData[(i * channels) + 2] = b;

        pixel_value = 0;
    }

    gluBuild2DMipmaps(GL_TEXTURE_2D, 3, image->w, image->h, GL_RGB, GL_UNSIGNED_BYTE, newData);

    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);    
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);

    delete [] newData;
 

}

texture::~texture() {
}

void swap(unsigned char & a, unsigned char & b)
{
    unsigned char temp;

    temp = a;
    a    = b;
    b    = temp;

    return;
}
